From 46f821e3996271eb4fd1a2d6eeab6d33d4450028 Mon Sep 17 00:00:00 2001
From: theofficialgman <28281419+theofficialgman@users.noreply.github.com>
Date: Sun, 6 Mar 2022 21:44:22 -0500
Subject: [PATCH] codec: avcodec: use filtered/best effort pts

fixes playback/stuttering with wrong mux/monotonically
increasing pts on frames that must be reordered.

no change for regular pts.
---
 modules/codec/avcodec/video.c | 5 +++++
 1 file changed, 5 insertions(+)

diff --git a/modules/codec/avcodec/video.c b/modules/codec/avcodec/video.c
index c5899fd736..9ba48614aa 100644
--- a/modules/codec/avcodec/video.c
+++ b/modules/codec/avcodec/video.c
@@ -1101,10 +1101,15 @@ static picture_t *DecodeBlock( decoder_t *p_dec, block_t **pp_block, bool *error
 
         /* Compute the PTS */
 #ifdef FF_API_PKT_PTS
+    # if LIBAVCODEC_VERSION_MICRO >= 100
+        mtime_t i_pts = frame->best_effort_timestamp;
+    # else
         mtime_t i_pts = frame->pts;
+    # endif
 #else
         mtime_t i_pts = frame->pkt_pts;
 #endif
+
         if (i_pts == AV_NOPTS_VALUE )
             i_pts = frame->pkt_dts;
 
-- 
2.25.1

